# coding: utf-8

"""
    WHMCS API

    Python client for the WHMCS API.  WHMCS (Web Host Manager Complete Solution) provides a single API endpoint that handles multiple operations through different 'action' parameters. This client supports various WHMCS operations for managing clients, orders, and other resources.  Authentication is handled through username/password or API credentials. All requests are sent as form-encoded data to the /api.php endpoint. 

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from whmcs_client.models.add_client_response import AddClientResponse
from whmcs_client.models.add_order_response import AddOrderResponse
from whmcs_client.models.update_client_response import UpdateClientResponse
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

WHMCSSUCCESSRESPONSE_ONE_OF_SCHEMAS = ["AddClientResponse", "AddOrderResponse", "UpdateClientResponse"]

class WHMCSSuccessResponse(BaseModel):
    """
    WHMCSSuccessResponse
    """
    # data type: AddClientResponse
    oneof_schema_1_validator: Optional[AddClientResponse] = None
    # data type: UpdateClientResponse
    oneof_schema_2_validator: Optional[UpdateClientResponse] = None
    # data type: AddOrderResponse
    oneof_schema_3_validator: Optional[AddOrderResponse] = None
    actual_instance: Optional[Union[AddClientResponse, AddOrderResponse, UpdateClientResponse]] = None
    one_of_schemas: Set[str] = { "AddClientResponse", "AddOrderResponse", "UpdateClientResponse" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = WHMCSSuccessResponse.model_construct()
        error_messages = []
        match = 0
        # validate data type: AddClientResponse
        if not isinstance(v, AddClientResponse):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AddClientResponse`")
        else:
            match += 1
        # validate data type: UpdateClientResponse
        if not isinstance(v, UpdateClientResponse):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UpdateClientResponse`")
        else:
            match += 1
        # validate data type: AddOrderResponse
        if not isinstance(v, AddOrderResponse):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AddOrderResponse`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in WHMCSSuccessResponse with oneOf schemas: AddClientResponse, AddOrderResponse, UpdateClientResponse. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in WHMCSSuccessResponse with oneOf schemas: AddClientResponse, AddOrderResponse, UpdateClientResponse. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into AddClientResponse
        try:
            instance.actual_instance = AddClientResponse.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into UpdateClientResponse
        try:
            instance.actual_instance = UpdateClientResponse.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AddOrderResponse
        try:
            instance.actual_instance = AddOrderResponse.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into WHMCSSuccessResponse with oneOf schemas: AddClientResponse, AddOrderResponse, UpdateClientResponse. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into WHMCSSuccessResponse with oneOf schemas: AddClientResponse, AddOrderResponse, UpdateClientResponse. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AddClientResponse, AddOrderResponse, UpdateClientResponse]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


